﻿

//*********************************************************************************************//
// Transmitter Page Popup Window                                                                      //
//*********************************************************************************************//

function sagdmx_tx_window(parent) {
    var self = this;
    this.parent = parent;
    this.win = null;
    this.hFunc0 = function () { self.hFunc_Click(); };
    this.hFunc1 = function () { self.hFunc_Hover(); };
    this.shown = false;
    this.fields = null;
    this.isAdd = null;
}

sagdmx_tx_window.prototype.show = function (WindowName, ReadOnly, SelectedSysId, TxStore, TxFaultsStore ) {
    var self = this;
    this.Name = WindowName;
    this.DevSysId = SelectedSysId;
    this.TxStore = TxStore;
    this.TxFaultsStore = TxFaultsStore;
    this.IsViewing = ReadOnly;

    if (this.win == null) {
        var div0, div1;

        this.outer = document.createElement("div");
        this.outer.className = "sagdmx_tx_outerplacement";

        this.container = document.createElement("div");
        this.container.className = "sagdmx_tx_placement";
        this.outer.appendChild(this.container);

        div0 = document.createElement("div");
        div0.className = "icon";
        this.container.appendChild(div0);

        div0 = document.createElement("div");
        div0.className = "form_outercontainer";
        this.container.appendChild(div0);

        div1 = document.createElement("div");
        div0.appendChild(div1);
        this.formContainer = div1;

        this.win = sagdmx.windows.createWindow('winTxForm', 0, 0, 850, 600);
        this.win.attachObject(this.container);


//////////////////////
//  Main TAB
//      General
//
        var frmstr = [
            { type:"settings" , labelWidth:80, inputWidth:250, position:"absolute"  },
            {type: "block", inputWidth: "auto", list:[
                { type:"label" , name:"form_label_2", label:"Transmitter Fields", width:250, labelLeft:5, labelTop:5  },
                { type:"input" , name:"transmitter_brand", label:"Brand", inputWidth:220, labelLeft:50, labelTop:50, inputLeft:130, inputTop:50  },
                { type:"input" , name:"transmitter_type", label:"Type", inputWidth:220, labelLeft:50, labelTop:75, inputLeft:130, inputTop:75  },
                { type:"input" , name:"modelnumber", label:"Model #", inputWidth:220, labelLeft:50, labelTop:100, inputLeft:130, inputTop:100  },
                { type:"input" , name:"serialnumber", label:"Serial #", inputWidth:220, labelLeft:50, labelTop:125, inputLeft:130, inputTop:125  },
                { type:"combo" , name:"locationsysid", label:"Location", inputWidth:170, labelLeft:50, labelTop:150, inputLeft:180, inputTop:150, readonly:"true", connector: "/data/locationnames" },
                { type:"combo" , name:"ipbscid", label:"Connect ipBSC", labelAlign:"left", inputWidth:170, labelLeft:50, labelTop:200, inputLeft:180, inputTop:200, readonly:"true", connector: "/data/ipbscids" },
                { type:"input" , name:"pendingtranscnt", hidden:"true" },
                { type:"input" , name:"sysid", hidden:"true" },
                { type:"input" , name:"commentsysid", hidden:"true" }
            ]},
//////////////////////
//  Main TAB
//      General
//
            {type: "block", inputWidth: "auto", id: "settings", list:[
                { type:"label" , name:"form_label_5", label:"Transmitter Settings", width:250, labelWidth:80, labelAlign:"left", labelLeft:5, labelTop:5  },
                { type:"input" , name:"pttoveride", label:"PTT Override", labelWidth:80, labelAlign:"left", inputWidth:170, labelLeft:75, labelTop:75, inputLeft:155, inputTop:75  },
                { type:"input" , name:"feedback", label:"Feedback", labelWidth:80, labelAlign:"left", inputWidth:170, labelLeft:75, labelTop:100, inputLeft:155, inputTop:100  },
                { type:"input" , name:"power", label:"Power", labelWidth:80, labelAlign:"left", inputWidth:170, labelLeft:75, labelTop:125, inputLeft:155, inputTop:125  },
                { type:"input" , name:"level", label:"Level", labelWidth:80, labelAlign:"left", inputWidth:170, labelLeft:75, labelTop:150, inputLeft:155, inputTop:150  },
                { type:"checkbox" , name:"txon", label:"Transmitter On", labelWidth:100, labelAlign:"left", labelLeft:75, labelTop:50, inputLeft:175, inputTop:50  }
            ]},
//////////////////////
//  Main TAB
//      General
//
            {type: "block", inputWidth: "auto", id: "network", list:[
                { type:"label" , name:"form_label_4", label:"Network Configuration", width:250, labelAlign:"left", labelLeft:5, labelTop:5  },
                { type:"checkbox" , name:"form_checkbox_1", label:"Directly Connected to ipBSC", labelWidth:175, labelAlign:"left", labelLeft:50, labelTop:50, inputLeft:225, inputTop:50  },
                { type:"block" , name:"form_block_1", inputLeft:60, inputTop:200, list:[
                    { type:"label" , name:"form_label_6", label:"Label"  },
                    { type:"input" , name:"form_input_5", label:"Input"  },
                    { type:"input" , name:"form_input_10", label:"Input"  },
                    { type:"input" , name:"form_input_11", label:"Input"  }
                ]}
            ]}
        ];
//
//////////////////////

//////////////////////
//  Adding TABs
//
        var tabbarStr = {
            parent: "tabbarObj",
            tabs: [
                {id: "TX", text: "General", active: true},
                {id: "tabSettings", text: "TX Settings"},
                {id: "tabNetwork", text: "Network Settings"},
                {id: "tabFaults", text: "Alarms and Thresholds"}
            ]
        };
        this.tabTransmitter = this.win.attachTabbar(tabbarStr);
        this.frmTX = this.tabTransmitter.cells("TX").attachForm(frmstr);
        this.tabTransmitter.tabs("tabSettings").attachObject("settings");
        this.tabTransmitter.tabs("tabNetwork").attachObject("network");
//
//////////////////////

//////////////////////
//  Main TAB
//      General
//
        this.Faults = this.tabTransmitter.cells('tabFaults');
        this.gridFaults = this.Faults.attachGrid();
        this.gridFaults.setIconsPath('./codebase/imgs/');

        this.gridFaults.setHeader(["Description","Report SNMP","Low Fault","Low Warning","Sensor Reading","High Warning","High Fault","Active Fault","Active Alarm","Last Updated"]);
        this.gridFaults.setColTypes("rotxt,ch,edn,edn,ron,edn,edn,ch,ch,rotxt");
        this.gridFaults.setColumnIds("fault_description,reportsnmp,lower_cutoff,minimum,sensor_value,maximum,upper_cutoff,active_fault,active_alarm,tx_datetime");
        this.gridFaults.setColAlign('left,left,center,center,center,center,left,center,center,right');
        this.gridFaults.setColVAlign('middle,middle,middle,middle,middle,middle,middle,middle,middle,middle');
        this.gridFaults.setColSorting('str,str,str,str,str,str,str,str,str,str');
        this.gridFaults.setInitWidths('200,50,60,60,60,60,60,50,50,125');
        this.gridFaults.attachEvent('onEditCell', function(stage,rId,cInd,nValue,oValue) {
            if ((self.IsViewing) || (self.IsLocked)) {
                return false;
            }
            else {
                if (cInd == '0' || cInd == '4' || cInd == '7' || cInd == '8' || cInd == '9')
                    return false;
                else return true;
            }

        });
        this.gridFaults.init();
//
//////////////////////

        this.win.setText('Configure the transmitter');
        this.win.setModal(1);
        this.win.centerOnScreen();
        this.win.button('minmax').show();
        this.win.button('minmax').enable();
    }

    if ((this.TxStore == null) && (this.DevSysId != null)) {

    }
    else if ((this.TxStore != null) && (this.DevSysId == null)) {
        //
        //  Loading from the Datastore
        //
        this.frmTX.bind(this.TxStore);

        this.gridFaults.sync(this.TxFaultsStore);
    }

//////////////////////
//  Toolbar and views
//
    this.hdrtoolbar = this.win.attachToolbar();
    this.hdrtoolbar.setIconsPath('./skinsCustom/skyblue/images/');
    if (this.frmTX.getItemValue("pendingtranscnt") > 0) {
        this.hdrtoolbar.loadStruct('<toolbar>' +
//            '                               <item type="button" id="btnEditTransmitter" text="Edit" img="Edit_16x16.png" title="Edit the fields in this Transmitter" />' +
            '                               <item type="button" id="btnCloseTransmitter" text="Close" img="Cancel_16x16.png" title="Close this window" />' +
            '                               <item type="separator" id="button_separator_2" />' +
//                '                               <item type="button" id="btnSaveTemplate" text="Save Template" img="Save_10x10.png" imgdis="" title="Save the data in this Transmitter for a template to use later" />' +
//                '                               <item type="separator" id="button_separator_3" />' +
            '                               <item type="button" id="btnRequestAllData" text="Update All Parameters" img="Synchronize_16x16.png" imgdis="" title="Update All the parameters of the Transmitter" />' +
            '                               <item type="button" id="btnRequestParams" text="Update Values" img="Synchronize_16x16.png" imgdis="" title="Reload the current values" />' +
            '                       </toolbar>');

        //
        //  We don't have to worry about the comment window, so lets just load it (but in read only mode)
        //
        this.IsLocked = true;
        this.isReadOnly(true);
        this.win.setText("View the Transmitter");

        this.win.show();
        this.win.center();
        this.shown = true;
    }
    else if (this.IsViewing) {
        this.hdrtoolbar.loadStruct('<toolbar><item type="button" id="btnEditTransmitter" text="Edit" img="Edit_16x16.png" title="Edit the fields in this Transmitter" />' +
            '                               <item type="button" id="btnCloseTransmitter" text="Close" img="Cancel_16x16.png" title="Close this window" />' +
            '                               <item type="separator" id="button_separator_2" />' +
//                '                               <item type="button" id="btnSaveTemplate" text="Save Template" img="Save_10x10.png" imgdis="" title="Save the data in this Transmitter for a template to use later" />' +
//                '                               <item type="separator" id="button_separator_3" />' +
            '                               <item type="button" id="btnRequestAllData" text="Update All Parameters" img="Synchronize_16x16.png" imgdis="" title="Update All the parameters of the Transmitter" />' +
            '                               <item type="button" id="btnRequestParams" text="Update Values" img="Synchronize_16x16.png" imgdis="" title="Reload the current values" />' +
            '                       </toolbar>');

        //
        //  We don't have to worry about the comment window, so lets just load it (but in read only mode)
        //
        this.isReadOnly(true);
        this.win.setText("View the Transmitter");

        this.win.show();
        this.win.center();
        this.shown = true;

    }
    else {
        this.hdrtoolbar.loadStruct('<toolbar><item type="button" id="btnSaveTransmitter" text="Save" img="Save_10x10.png" title="Save the changes to the Transmitter" />' +
            '                               <item type="button" id="btnCloseTransmitter" text="Close" img="Cancel_16x16.png" title="Close this window" />' +
            '                               <item type="separator" id="button_separator_2" />' +
//                '                               <item type="button" id="btnLoadTemplate" text="Load Template" img="Folder_16x16.png" title="Load the data for this Transmitter from a template" />' +
//                '                               <item type="button" id="btnSaveTemplate" text="Save Template" img="Save_10x10.png" imgdis="" title="Save the data in this Transmitter for a template to use later" />' +
//                '                               <item type="separator" id="button_separator_3" />' +
            '                               <item type="button" id="btnRequestAllData" text="Update All Parameters" img="Synchronize_16x16.png" imgdis="" title="Update All the parameters of the Transmitter" />' +
            '                               <item type="button" id="btnRequestParams" text="Update Values" img="Synchronize_16x16.png" imgdis="" title="Reload the current values" />' +
            '                       </toolbar>');

        //
        //   We hide it until we know about the comments
        //
        this.isReadOnly(false);
        this.win.setText("Edit the Transmitter");

        this.shown = false;
        this.win.setModal(false);
        this.win.hide();

        this.winComment = new sagdmx_comment_window(this);
        this.winComment.show("Comment", null);
    }

    this.hdrtoolbar.attachEvent("onClick", function(id) {
        if (id == "btnEditTransmitter") {
            self.hFormEditReq();
        }
        else if (id == "btnSaveTransmitter") {
            //self.hFormValidate();
            self.hFormClick(true);
        }
        else if (id == "btnCloseTransmitter") {
            self.hide();
        }
        else if (id == "btnSaveTemplate") {
        }
        else if (id == "btnLoadTemplate") {
        }
        else if (id == "btnRequestAllData") {
        }
        else if (id == "btnRequestParams") {
        }
        else { // WTF
            alert("<b>Something impossible just happened</b> Please report this.");
        }
    });
//
////////////////////////
};



sagdmx_tx_window.prototype.hFormEditReq = function () {
    //
    //  TODO: Is User Validation is ok with this??
    //

    //
    //   We hide it until we know about the comments
    //
    this.isReadOnly(false);
    this.win.setText("Edit the ipBSC");

    this.shown = false;
    this.win.setModal(false);
    this.win.hide();

    this.winComment = new sagdmx_comment_window(this);
    this.winComment.show("Comment", null);
}

sagdmx_tx_window.prototype.hFormValidate = function (status) {
    this.valid = status;
};

sagdmx_tx_window.prototype.windowReturned = function (WindowName, SysId, SaveStatus) {
    if (SaveStatus) {

    }
}


sagdmx_tx_window.prototype.CommentWindowReturned = function (SaveStatus) {
    if (SaveStatus) {
        this.hdrtoolbar.clearAll();
        this.hdrtoolbar.loadStruct('<toolbar><item type="button" id="btnSaveTransmitter" text="Save" img="Save_10x10.png" title="Save the changes to the Transmitter" />' +
            '                               <item type="button" id="btnCloseTransmitter" text="Close" img="Cancel_16x16.png" title="Close this window" />' +
            '                               <item type="separator" id="button_separator_2" />' +
//                '                               <item type="button" id="btnLoadTemplate" text="Load Template" img="Folder_16x16.png" title="Load the data for this Transmitter from a template" />' +
//                '                               <item type="button" id="btnSaveTemplate" text="Save Template" img="Save_10x10.png" imgdis="" title="Save the data in this Transmitter for a template to use later" />' +
//                '                               <item type="separator" id="button_separator_3" />' +
            '                               <item type="button" id="btnRequestAllData" text="Update All Parameters" img="Synchronize_16x16.png" imgdis="" title="Update All the parameters of the Transmitter" />' +
            '                               <item type="button" id="btnRequestParams" text="Update Values" img="Synchronize_16x16.png" imgdis="" title="Reload the current values" />' +
            '                       </toolbar>');

        this.win.show();
        this.win.center();
        this.shown = true;
    }
    else {
        //
        //  TODO: Rename this return function?
        //
        this.hide();
        this.parent.windowReturned(this.Name, this.DevSysId, false);
    }
};



//
// This goes through the whole form and adjusts it to be read only or editable
//
sagdmx_tx_window.prototype.setReadOnly = function (theform, id) {
    var Type = theform.getItemType(id);

    switch (Type) {
        case "password":
        case "input":
        {
            theform.disableItem(id);
            //(this.form.getInput(id)).readonly = true;
            break;
        }

        case "checkbox":
        {
            theform.disableItem(id);
            break;
        }

        case "radio":
        {
            theform.disableItem(id);
            break;
        }

        case "combo":
        {
            theform.disableItem(id);
            //(this.form.getCombo(id)).readonly = true;
            break;
        }
    }
}

sagdmx_tx_window.prototype.setReadWrite = function (theform, id) {
    var Type = theform.getItemType(id);

    switch (Type) {
        case "password":
        case "input":
        {
            theform.enableItem(id);
            //(this.form.getInput(id)).readonly = true;
            break;
        }

        case "checkbox":
        {
            theform.enableItem(id);
            break;
        }

        case "radio":
        {
            theform.enableItem(id);
            break;
        }

        case "combo":
        {
            theform.enableItem(id);
            //(this.form.getCombo(id)).readonly = true;
            break;
        }
    }
}

sagdmx_tx_window.prototype.isReadOnly = function (isReadOnly) {
    var self = this;

    if (isReadOnly == null) {
        return this.ReadOnly;
    }

    this.IsViewing = isReadOnly;

    if (isReadOnly) {
//        this.frmSettings.forEachItem(function (id) { self.setReadOnly(self.frmSettings, id); });
//        this.frmNetwork.forEachItem(function (id) { self.setReadOnly(self.frmNetwork, id); });
        this.frmTX.forEachItem(function (id) { self.setReadOnly(self.frmTX, id); });
    }
    else {
//        this.frmSettings.forEachItem(function (id) { self.setReadWrite(self.frmSettings, id); });
//        this.frmNetwork.forEachItem(function (id) { self.setReadWrite(self.frmNetwork, id); });
        this.frmTX.forEachItem(function (id) { self.setReadWrite(self.frmTX, id); });
    }
}



sagdmx_tx_window.prototype.hide = function () {
    if (this.shown) {
        this.shown = false;
        this.win.setModal(false);
        this.win.hide();
    }
};

sagdmx_tx_window.prototype.hFormClick = function (saved) {
    //if ((!saved) || (!this.valid)) {
    if (!saved) {
        this.hide();

        //
        //  TODO: Rename this return function?
        //
        this.parent.windowReturned(this.Name, this.DevSysId, false);
    }
    else {
        //
        //  Validation is conpleted,
        //      Save the to the datastore (if applicable)
        //      Save the transaction
        //      Return

        //
        //  This is only called via the datagrid, otherwise the dataprocessor will write it to the Database
        //
        if (this.TxStore != null) {
            this.frmTX.save();
            //this.gridFaults.save();
        }

        this.DevSysId = (this.frmTX.getItemValue("sysid"));
        this.fields = this.getFields();
        var NewTrans = new sagdmx.DBTransaction("TX", "update", this.fields["serialnumber"], this.DevSysId, this.fields, this.oldfields);
        sagdmx.TransQ.addTransaction(NewTrans);

        //
        //  Again, rename?
        //
        this.parent.windowReturned(this.Name, this.DevSysId, this.fields);

        this.hide();
    }
};

sagdmx_tx_window.prototype.hFormValidate = function (status) {
    this.valid = status;
};


sagdmx_tx_window.prototype.collectValue = function (dataform, id) {
    var Type = dataform.getItemType(id);

    switch (Type) {
        case "password":
        case "input":
        {
            //this.fieldCollection[id] = (this.form.getItemValue(id)).trim();
            this.fieldCollection[id] = (dataform.getItemValue(id));
            break;
        }

        case "checkbox":
        {
            if (dataform.isItemChecked(id)) {
                this.fieldCollection[id] = 1; //(dataform.isItemChecked(id));
            }
            else {
                this.fieldCollection[id] = 0; //1; (dataform.isItemChecked(id));
            }
            //this.fieldCollection[id] = (dataform.isItemChecked(id));
            break;
        }

        case "combo":
        {
            this.fieldCollection[id] = (dataform.getCombo(id).getSelectedValue());
            break;
        }

        case "radio":
        {
            this.fieldCollection[id] = (dataform.getCheckedValue(id));
            break;
        }
    }
}

sagdmx_tx_window.prototype.getFields = function () {
    var self = this;

    this.fieldCollection = new Object();

    this.frmTX.forEachItem(function (id) { self.collectValue(self.frmTX, id); });

    return this.fieldCollection;
}



